diff --git a/lib/hive/daemon/auto_retry/coordinator.rb b/lib/hive/daemon/auto_retry/coordinator.rb
new file mode 100644
index 00000000..f4bf1df7
--- /dev/null
+++ b/lib/hive/daemon/auto_retry/coordinator.rb
@@ -0,0 +1,755 @@
+# frozen_string_literal: true
+
+require "digest"
+require "securerandom"
+require "hive/daemon/auto_retry/classifier"
+require "hive/daemon/auto_retry/evidence"
+require "hive/daemon/auto_retry/health"
+require "hive/daemon/auto_retry/policy"
+require "hive/daemon/auto_retry/safety"
+require "hive/daemon/auto_retry/state"
+require "hive/recovery_sequence"
+require "hive/events"
+require "hive/markers"
+
+module Hive
+  module Daemon
+    module AutoRetry
+      # Orchestrates v1 health-gated auto-retry: classify → safety → policy
+      # → probe → re-check safety → queue guarded clear + same-stage rerun.
+      class Coordinator
+        def initialize(logger:, controller:, state: nil, health: nil,
+                       request_queue: nil, enabled: true,
+                       config_for_project: nil, project_enabled: nil,
+                       legacy_projects: nil, clock: -> { Time.now },
+                       dry_run: false)
+          @logger = logger
+          @controller = controller
+          @state = state || State.new(logger: logger, clock: clock)
+          @health = health || Health.new(clock: clock)
+          @request_queue = request_queue || Hive::Daemon::DispatchRequestQueue
+          @enabled = enabled
+          @config_for_project = config_for_project || ->(_name) { {} }
+          @project_enabled = project_enabled || ->(_name) { true }
+          @legacy_projects = legacy_projects || {}
+          @clock = clock
+          @dry_run = dry_run
+          @probes_this_tick = 0
+          @probe_cursor = 0
+        end
+
+        attr_accessor :enabled
+
+        def reconfigure!(enabled:)
+          @enabled = enabled
+        end
+
+        # Called by the dispatcher immediately before spawning an auto-retry
+        # same-stage rerun. Persists attempt accounting; returns false if the
+        # durable write fails (caller must not spawn).
+        def note_retry_dispatched!(recovery_id:, project:, slug:, stage:, reason:,
+                                   fingerprint: nil, task_id: nil)
+          task_key = State.task_key(task_id: task_id, slug: slug)
+          rec = @state.get(project: project, task_key: task_key, stage: stage, reason: reason)
+          return false unless rec.is_a?(Hash)
+          return false unless rec["recovery_id"].to_s == recovery_id.to_s
+          fp = fingerprint || rec["pending_fingerprint"] || rec["last_probe_fingerprint"]
+          @state.mark_dispatched!(
+            project: project, task_key: task_key, stage: stage, reason: reason,
+            fingerprint: fp, recovery_id: recovery_id
+          )
+          true
+        rescue State::Error => e
+          @logger&.event(:auto_retry_state_error, message: e.message)
+          false
+        end
+
+        def tick(rows, now: @clock.call)
+          @probes_this_tick = 0
+          @health.reset_tick_cache!
+          return unless @enabled
+          return if @state.suspended?
+
+          rows = Array(rows)
+          reconcile_records_without_current_stage(rows, now: now)
+          ordered_rows = fair_rows(rows)
+          ordered_rows.each do |row|
+            evaluate_row(row, now: now)
+          rescue StandardError => e
+            @logger&.event(:auto_retry_error,
+                           project: row_get(row, :project),
+                           slug: row_get(row, :slug),
+                           error_class: e.class.name,
+                           message: e.message)
+          end
+          advance_probe_cursor(rows.length)
+        end
+
+        # Called after a successful manual markers clear (no recovery_id).
+        def on_manual_clear!(project:, task_key:, stage:, reason:)
+          return if reason.to_s.empty?
+
+          @state.rearm_manual!(project: project, task_key: task_key,
+                               stage: stage, reason: reason)
+          audit(project: project, slug: task_key, stage: stage,
+                action: "manual_rearm", rationale: "manual_clear",
+                marker_reason: reason, recovery_class: nil)
+        rescue State::Suspended => e
+          @logger&.event(:auto_retry_state_error, message: e.message)
+        end
+
+        private
+
+        def evaluate_row(row, now:)
+          project = row_get(row, :project).to_s
+          slug = row_get(row, :slug).to_s
+          stage = row_get(row, :stage).to_s
+          task_key = State.task_key(task_id: row_get(row, :id), slug: slug)
+          inflight = inflight_record_for(project: project, task_key: task_key, stage: stage)
+          if inflight
+            reconcile_inflight(row, inflight, task_key, now: now)
+            return
+          end
+
+          marker = row_get(row, :marker).to_s.downcase
+          return unless marker == "error"
+
+          attrs = row_get(row, :marker_attrs) || {}
+          reason = (attrs["reason"] || attrs[:reason]).to_s
+          return if reason.empty?
+
+          folder = row_get(row, :folder).to_s
+          marker_id = (attrs["marker_id"] || attrs[:marker_id]).to_s
+
+          # Merge-watcher precedence for finalize.
+          if stage == "8-finalize" # coding-scoped: finalize recovery belongs to merge watcher
+            return audit_negative(row, "merge_watcher_owned", nil, now: now)
+          end
+
+          unless @project_enabled.call(project)
+            return audit_negative(row, "project_disabled", nil, now: now)
+          end
+
+          config = @config_for_project.call(project) || {}
+          evidence = Evidence.load(
+            folder: folder,
+            state_file: row_get(row, :state_file),
+            marker_attrs: attrs
+          )
+          classification = Classifier.classify(
+            row: row, config: config, evidence: evidence.to_h
+          )
+          unless classification.eligible?
+            return audit_negative(row, classification.rationale,
+                                  classification.recovery_class, now: now)
+          end
+
+          record = @state.get(project: project, task_key: task_key,
+                              stage: stage, reason: reason) || {}
+
+          safety = Safety.new(
+            controller: @controller,
+            enabled_projects: nil,
+            legacy_projects: @legacy_projects
+          )
+          unless @project_enabled.call(project)
+            return audit_negative(row, "project_disabled", classification.recovery_class, now: now)
+          end
+          if @legacy_projects[project]
+            return audit_negative(row, "legacy_layout", classification.recovery_class, now: now)
+          end
+
+          gate = safety.check(
+            row: row,
+            observed_marker_id: marker_id,
+            observed_reason: reason,
+            re_read: false
+          )
+          unless gate.safe?
+            return audit_negative(row, gate.rationale, classification.recovery_class, now: now)
+          end
+
+          # The pre-probe decision is only an exhaustion/in-flight gate. In
+          # particular, do not reject attempt two for the *old* fingerprint
+          # before a changed cheap health signal gets its fresh probe.
+          decision = Policy.decide(record: record, healthy_fingerprint: nil, now: now)
+          if decision.action == :refuse
+            if decision.rationale == "exhausted"
+              begin
+                @state.mark_exhausted!(project: project, task_key: task_key,
+                                       stage: stage, reason: reason)
+              rescue State::Suspended
+                nil
+              end
+            end
+            return audit_negative(row, decision.rationale, classification.recovery_class, now: now)
+          end
+
+          signal = health_signal(classification, config, row)
+          signal_changed = !signal.to_s.empty? && signal.to_s != record["last_probe_signal"].to_s
+          need_probe = record["last_probe_at"].to_s.empty? || signal_changed ||
+                       Policy.should_reprobe?(record: record, now: now)
+          health_result = nil
+          if need_probe
+            cache_hit = health_cache_hit?(classification, config, row)
+            if !cache_hit && @probes_this_tick >= Policy::MAX_UNIQUE_PROBES_PER_TICK
+              return audit_negative(row, "probe_budget_deferred", classification.recovery_class, now: now)
+            end
+            @probes_this_tick += 1 unless cache_hit
+            health_result = @health.probe(
+              recovery_class: classification.recovery_class,
+              config: config,
+              project_root: project_root_for(row),
+              stage: stage
+            )
+            begin
+              @state.upsert!(
+                project: project, task_key: task_key, stage: stage, reason: reason,
+                last_probe_at: now,
+                last_probe_fingerprint: health_result.fingerprint,
+                last_probe_healthy: health_result.healthy,
+                last_probe_rationale: health_result.rationale,
+                last_probe_signal: signal,
+                marker_id: marker_id,
+                phase: record["phase"] || "candidate"
+              )
+            rescue State::Suspended => e
+              @logger&.event(:auto_retry_state_error, message: e.message)
+              return
+            end
+            unless health_result.healthy
+              return audit_negative(row, health_result.rationale || "probe_unhealthy",
+                                    classification.recovery_class, now: now,
+                                    extra: { probes: health_result.probes,
+                                             correlation_id: health_result.correlation_id })
+            end
+          else
+            unless record["last_probe_healthy"] == true
+              return audit_negative(
+                row,
+                record["last_probe_rationale"].to_s.empty? ? "probe_unhealthy_cached" : record["last_probe_rationale"],
+                classification.recovery_class,
+                now: now,
+                extra: { probe_cached: true, next_probe_at: next_probe_at(record) }
+              )
+            end
+            health_result = Health::ProbeSetResult.new(
+              healthy: true,
+              fingerprint: record["last_probe_fingerprint"],
+              probes: [],
+              rationale: "cached",
+              correlation_id: nil
+            )
+          end
+
+          decision = Policy.decide(
+            record: @state.get(project: project, task_key: task_key, stage: stage, reason: reason) || record,
+            healthy_fingerprint: health_result.fingerprint,
+            now: now
+          )
+
+          case decision.action
+          when :wait
+            begin
+              rec = @state.get(project: project, task_key: task_key, stage: stage, reason: reason) || {}
+              if rec["second_candidate_fingerprint"].to_s != health_result.fingerprint.to_s
+                @state.upsert!(
+                  project: project, task_key: task_key, stage: stage, reason: reason,
+                  second_candidate_fingerprint: health_result.fingerprint,
+                  second_candidate_first_seen_at: now,
+                  eligible_at: decision.eligible_at
+                )
+              end
+            rescue State::Suspended
+              nil
+            end
+            audit_negative(row, decision.rationale, classification.recovery_class, now: now,
+                           extra: { eligible_at: decision.eligible_at&.utc&.iso8601 })
+          when :retry, :probe
+            return if decision.action == :probe && !health_result.healthy
+
+            # Re-check safety immediately before queueing clear.
+            gate2 = safety.check(row: row, observed_marker_id: marker_id,
+                                 observed_reason: reason, re_read: true)
+            unless gate2.safe?
+              return audit_negative(row, gate2.rationale, classification.recovery_class, now: now)
+            end
+
+            dispatch_clear_and_retry(
+              row: row, classification: classification, task_key: task_key,
+              health_result: health_result, reason: reason, marker_id: marker_id,
+              now: now
+            )
+          else
+            audit_negative(row, decision.rationale, classification.recovery_class, now: now)
+          end
+        end
+
+        def dispatch_clear_and_retry(row:, classification:, task_key:, health_result:,
+                                     reason:, marker_id:, now:)
+          project = row_get(row, :project).to_s
+          slug = row_get(row, :slug).to_s
+          stage = row_get(row, :stage).to_s
+          attrs = row_get(row, :marker_attrs) || {}
+          match_attr = Hive::RecoverySequence.match_attr_for_error(attrs)
+          match_attr ||= "marker_id=#{marker_id},reason=#{reason}" if !marker_id.empty?
+
+          recovery_id = "ar-#{SecureRandom.hex(8)}"
+          clear_rid = request_id_for(recovery_id, "clear")
+          retry_rid = request_id_for(recovery_id, "rerun")
+          commands = Hive::RecoverySequence.commands(
+            project: project,
+            slug: slug,
+            stage: stage,
+            marker: "ERROR",
+            match_attr: match_attr,
+            workflow: row_get(row, :workflow)
+          )
+          return audit_negative(row, "no_retry_verb", classification.recovery_class, now: now) if commands.empty?
+
+          clear_argv = commands[0]
+          # Attach internal recovery id for auto-clear path.
+          if clear_argv && clear_argv[1] == "markers"
+            clear_argv = clear_argv + [ "--recovery-id", recovery_id ]
+          end
+          rerun_argv = commands[1] || commands[0]
+
+          if @dry_run
+            audit(project: project, slug: slug, stage: stage,
+                  action: "dry_run_queue", rationale: "would_clear_and_retry",
+                  marker_reason: reason, recovery_class: classification.recovery_class,
+                  task_id: row_get(row, :id), marker_id: marker_id,
+                  recovery_id: recovery_id, fingerprint: health_result.fingerprint,
+                  probes: health_result.probes,
+                  correlation_id: health_result.correlation_id)
+            return
+          end
+
+          begin
+            @state.upsert!(
+              project: project, task_key: task_key, stage: stage, reason: reason,
+              phase: "clear_queued",
+              recovery_id: recovery_id,
+              recovery_class: classification.recovery_class,
+              slug: slug,
+              folder: row_get(row, :folder),
+              marker_id: marker_id,
+              last_probe_fingerprint: health_result.fingerprint,
+              pending_fingerprint: health_result.fingerprint,
+              clear_argv: clear_argv,
+              rerun_argv: rerun_argv,
+              clear_request_id: clear_rid,
+              retry_request_id: retry_rid
+            )
+          rescue State::Suspended => e
+            @logger&.event(:auto_retry_state_error, message: e.message)
+            return
+          end
+
+          # Publish the continuation sidecar before the runnable clear request.
+          # A crash can therefore leave an inert sidecar, never a clear-only
+          # request that strands a markerless task.
+          if rerun_argv && rerun_argv != clear_argv
+            begin
+              @request_queue.write_sequence!(clear_rid, remaining_argvs: [ rerun_argv ],
+                                                       state_home: state_home_for_queue,
+                                                       recovery_id: recovery_id)
+            rescue StandardError => e
+              @logger&.event(:auto_retry_sequence_error, message: e.message)
+              return
+            end
+          end
+
+          published = ensure_request!(
+            project: project, slug: slug, argv: clear_argv,
+            recovery_id: recovery_id, recovery_step: "clear",
+            request_id: clear_rid
+          )
+          return unless published
+
+          audit(project: project, slug: slug, stage: stage,
+                action: "queue_clear_and_retry",
+                rationale: "healthy_and_safe",
+                marker_reason: reason,
+                recovery_class: classification.recovery_class,
+                task_id: row_get(row, :id),
+                marker_id: marker_id,
+                recovery_id: recovery_id,
+                request_id: clear_rid,
+                fingerprint: health_result.fingerprint,
+                attempt: ((@state.get(project: project, task_key: task_key, stage: stage, reason: reason) || {})["attempts_dispatched"].to_i + 1),
+                max_attempts: Policy::MAX_ATTEMPTS,
+                probes: health_result.probes,
+                correlation_id: health_result.correlation_id,
+                folder: row_get(row, :folder))
+        end
+
+        def reconcile_inflight(row, record, task_key, now:)
+          project = row_get(row, :project).to_s
+          slug = row_get(row, :slug).to_s
+          stage = row_get(row, :stage).to_s
+          reason = record["reason"] || (row_get(row, :marker_attrs) || {})["reason"]
+          phase = record["phase"].to_s
+          @logger&.event(:auto_retry_reconcile,
+                         project: project, slug: slug, stage: stage,
+                         phase: phase, recovery_id: record["recovery_id"])
+
+          marker = row_get(row, :marker).to_s.downcase
+          attrs = row_get(row, :marker_attrs) || {}
+          current_reason = (attrs["reason"] || attrs[:reason]).to_s
+          current_marker_id = (attrs["marker_id"] || attrs[:marker_id]).to_s
+          same_marker = marker == "error" && current_reason == reason.to_s &&
+                        (record["marker_id"].to_s.empty? ||
+                         current_marker_id == record["marker_id"].to_s)
+
+          if phase == "retry_dispatched"
+            return if @controller&.running_task?(project: project, slug: slug)
+            # Accounting is persisted before spawn. If spawn then fails, the
+            # dispatcher releases the claim back to the same durable request.
+            # Keep the idempotent dispatch transition live until that exact
+            # request is successfully claimed/spawned and removed on reap.
+            return if request_exists?(record["retry_request_id"])
+
+            if marker == "error" && current_reason == reason.to_s && !same_marker
+              terminal = record["attempts_dispatched"].to_i >= Policy::MAX_ATTEMPTS ? "exhausted" : "failed"
+              transition_record!(record, phase: terminal, marker_id: current_marker_id)
+              audit_terminal(row, record, terminal, now: now)
+            elsif terminal_success_marker?(marker) || stage != record["stage"].to_s
+              transition_record!(record, phase: "succeeded")
+              audit_terminal(row, record, "succeeded", now: now)
+            elsif marker == "error" || marker == "none"
+              transition_record!(record, phase: "aborted")
+              audit_terminal(row, record, "aborted", now: now)
+            else
+              transition_record!(record, phase: "aborted")
+              audit_terminal(row, record, "aborted", now: now)
+            end
+            return
+          end
+
+          if same_marker
+            publish_clear_from_record(record)
+          elsif marker == "none"
+            publish_rerun_from_record(record)
+          elsif terminal_success_marker?(marker)
+            transition_record!(record, phase: "succeeded")
+          else
+            transition_record!(record, phase: "aborted")
+          end
+        end
+
+        def ensure_request!(project:, slug:, argv:, recovery_id:, recovery_step:, request_id: nil)
+          request_id ||= request_id_for(recovery_id, recovery_step)
+          return request_id if request_exists?(request_id)
+
+          @request_queue.write_request!(
+            project: project,
+            slug: slug,
+            argv: argv,
+            requestor: "auto_retry",
+            trigger: "auto_retry:#{recovery_step}",
+            request_id: request_id,
+            recovery_id: recovery_id,
+            recovery_step: recovery_step
+          )
+          request_id
+        rescue StandardError => e
+          @logger&.event(:auto_retry_queue_error, message: e.message)
+          nil
+        end
+
+        def request_id_for(recovery_id, recovery_step)
+          ::Digest::SHA256.hexdigest("#{recovery_id}:#{recovery_step}")[0, 16]
+        end
+
+        def request_exists?(request_id)
+          if @request_queue.respond_to?(:request_exists?)
+            return @request_queue.request_exists?(request_id, state_home: state_home_for_queue)
+          end
+
+          Array(@request_queue.pending).any? { |request| request.request_id.to_s == request_id.to_s }
+        rescue StandardError
+          false
+        end
+
+        def publish_clear_from_record(record)
+          return abort_incoherent_record(record) unless coherent_recovery_record?(record)
+
+          clear_id = record["clear_request_id"].to_s
+          rerun = Array(record["rerun_argv"])
+          @request_queue.write_sequence!(
+            clear_id,
+            remaining_argvs: [ rerun ],
+            state_home: state_home_for_queue,
+            recovery_id: record["recovery_id"]
+          )
+          ensure_request!(
+            project: record["project"], slug: record["slug"],
+            argv: Array(record["clear_argv"]), recovery_id: record["recovery_id"],
+            recovery_step: "clear", request_id: clear_id
+          )
+        rescue StandardError => e
+          @logger&.event(:auto_retry_reconcile, phase: record["phase"],
+                         recovery_id: record["recovery_id"], error_class: e.class.name,
+                         message: e.message)
+          false
+        end
+
+        def publish_rerun_from_record(record)
+          return abort_incoherent_record(record) unless coherent_recovery_record?(record)
+
+          transition_record!(record, phase: "retry_queued")
+          ensure_request!(
+            project: record["project"], slug: record["slug"],
+            argv: Array(record["rerun_argv"]), recovery_id: record["recovery_id"],
+            recovery_step: "rerun", request_id: record["retry_request_id"]
+          )
+        end
+
+        def coherent_recovery_record?(record)
+          !record["project"].to_s.empty? && !record["slug"].to_s.empty? &&
+            !record["stage"].to_s.empty? && !record["reason"].to_s.empty? &&
+            !record["recovery_id"].to_s.empty? &&
+            !record["clear_request_id"].to_s.empty? &&
+            !record["retry_request_id"].to_s.empty? &&
+            Array(record["clear_argv"]).any? && Array(record["rerun_argv"]).any?
+        end
+
+        def abort_incoherent_record(record)
+          transition_record!(record, phase: "aborted", terminal_rationale: "incoherent_recovery_record")
+          false
+        rescue State::Error => e
+          @logger&.event(:auto_retry_state_error, message: e.message)
+          false
+        end
+
+        def transition_record!(record, phase:, **fields)
+          @state.upsert!(
+            project: record.fetch("project"), task_key: record.fetch("task_key"),
+            stage: record.fetch("stage"), reason: record.fetch("reason"),
+            phase: phase, **fields
+          )
+        end
+
+        def inflight_record_for(project:, task_key:, stage:)
+          @state.load_all.values.find do |record|
+            record.is_a?(Hash) && record["project"].to_s == project.to_s &&
+              record["task_key"].to_s == task_key.to_s &&
+              record["stage"].to_s == stage.to_s &&
+              %w[clear_queued marker_cleared retry_queued retry_dispatched].include?(record["phase"].to_s)
+          end
+        end
+
+        def reconcile_records_without_current_stage(rows, now:)
+          @state.load_all.values.each do |record|
+            next unless record.is_a?(Hash)
+            next unless %w[clear_queued marker_cleared retry_queued retry_dispatched].include?(record["phase"].to_s)
+
+            row = rows.find { |candidate| row_matches_record?(candidate, record) }
+            # A temporarily absent row is not authoritative terminal state.
+            next unless row
+            next if row_get(row, :stage).to_s == record["stage"].to_s
+
+            terminal = record["phase"].to_s == "retry_dispatched" ? "succeeded" : "aborted"
+            transition_record!(record, phase: terminal)
+            audit_terminal(row, record, terminal, now: now) if row
+          end
+        rescue State::Error => e
+          @logger&.event(:auto_retry_state_error, message: e.message)
+        end
+
+        def row_matches_record?(row, record)
+          return false unless row_get(row, :project).to_s == record["project"].to_s
+
+          slug_match = !record["slug"].to_s.empty? && row_get(row, :slug).to_s == record["slug"].to_s
+          id_match = !record["task_key"].to_s.empty? && row_get(row, :id).to_s == record["task_key"].to_s
+          slug_match || id_match
+        end
+
+        def fair_rows(rows)
+          return rows if rows.empty?
+
+          rows.rotate(@probe_cursor % rows.length)
+        end
+
+        def advance_probe_cursor(row_count)
+          return if row_count.zero?
+
+          @probe_cursor = (@probe_cursor + Policy::MAX_UNIQUE_PROBES_PER_TICK) % row_count
+        end
+
+        def health_signal(classification, config, row)
+          return nil unless @health.respond_to?(:signal_fingerprint)
+
+          @health.signal_fingerprint(
+            recovery_class: classification.recovery_class,
+            config: config,
+            project_root: project_root_for(row),
+            stage: row_get(row, :stage)
+          )
+        end
+
+        def health_cache_hit?(classification, config, row)
+          return false unless @health.respond_to?(:cached?)
+
+          @health.cached?(
+            recovery_class: classification.recovery_class,
+            config: config,
+            project_root: project_root_for(row),
+            stage: row_get(row, :stage)
+          )
+        end
+
+        def next_probe_at(record)
+          last = Policy.send(:parse_time, record["last_probe_at"])
+          last && (last + Policy::FALLBACK_REPROBE_SEC).utc.iso8601
+        rescue StandardError
+          nil
+        end
+
+        def terminal_success_marker?(marker)
+          %w[complete execute_complete review_complete waiting review_waiting execute_waiting].include?(marker.to_s)
+        end
+
+        def audit_terminal(row, record, terminal, now:)
+          attrs = row ? (row_get(row, :marker_attrs) || {}) : {}
+          audit(
+            project: record["project"], slug: record["slug"], stage: record["stage"],
+            action: terminal, rationale: "authoritative_status",
+            marker_reason: record["reason"], recovery_class: record["recovery_class"],
+            folder: row && row_get(row, :folder), recovery_id: record["recovery_id"],
+            task_id: row ? row_get(row, :id) : record["task_key"],
+            marker_id: attrs["marker_id"] || attrs[:marker_id] || record["marker_id"],
+            fingerprint: record["last_attempted_fingerprint"] || record["last_probe_fingerprint"],
+            request_id: record["retry_request_id"],
+            attempt: record["attempts_dispatched"].to_i,
+            max_attempts: Policy::MAX_ATTEMPTS, observed_at: now.utc.iso8601
+          )
+        end
+
+        def state_home_for_queue
+          Hive::Paths.state_home
+        end
+
+        def project_root_for(row)
+          folder = row_get(row, :folder).to_s
+          return nil if folder.empty?
+
+          # task folder is <root>/.hive-state/stages/<stage>/<slug>
+          parts = folder.split(File::SEPARATOR)
+          idx = parts.rindex(".hive-state")
+          return nil unless idx && idx.positive?
+
+          File.join(*parts[0...idx])
+        end
+
+        def audit_negative(row, rationale, recovery_class, now:, extra: {})
+          project = row_get(row, :project).to_s
+          slug = row_get(row, :slug).to_s
+          stage = row_get(row, :stage).to_s
+          attrs = row_get(row, :marker_attrs) || {}
+          reason = (attrs["reason"] || attrs[:reason]).to_s
+          task_key = State.task_key(task_id: row_get(row, :id), slug: slug)
+          sig = "#{rationale}|#{recovery_class}|#{attrs['marker_id']}"
+          record = @state.get(project: project, task_key: task_key, stage: stage, reason: reason) || {}
+          return unless Policy.should_emit_negative?(record: record, signature: sig, now: now)
+
+          begin
+            @state.upsert!(
+              project: project, task_key: task_key, stage: stage, reason: reason,
+              last_negative_signature: sig,
+              last_negative_at: now
+            )
+          rescue State::Suspended
+            nil
+          end
+
+          facts = {
+            task_id: row_get(row, :id),
+            marker_id: attrs["marker_id"] || attrs[:marker_id],
+            fingerprint: record["last_probe_fingerprint"],
+            attempt: record["attempts_dispatched"].to_i,
+            max_attempts: Policy::MAX_ATTEMPTS,
+            recovery_id: record["recovery_id"],
+            phase: record["phase"]
+          }.merge(extra)
+          audit(project: project, slug: slug, stage: stage,
+                action: "refuse", rationale: rationale,
+                marker_reason: reason, recovery_class: recovery_class,
+                folder: row_get(row, :folder),
+                **facts)
+        end
+
+        def audit(project:, slug:, stage:, action:, rationale:, marker_reason:,
+                  recovery_class:, folder: nil, **extra)
+          payload = {
+            project: project,
+            slug: slug,
+            stage: stage,
+            action: action,
+            rationale: rationale,
+            marker_reason: marker_reason,
+            recovery_class: recovery_class&.to_s,
+            ts: @clock.call.utc.iso8601
+          }.merge(extra)
+
+          @logger&.event(:auto_retry_decision, **payload)
+
+          return if folder.to_s.empty?
+
+          begin
+            Hive::Events.emit(
+              task_folder: folder,
+              slug: slug,
+              stage: stage,
+              event_type: :auto_retry_decision,
+              agent: "daemon",
+              message: "#{action}:#{rationale}",
+              details: bound_details(payload)
+            )
+          rescue ArgumentError
+            # events may not know the type until Unit 6 wires it
+            Hive::Events.emit(
+              task_folder: folder,
+              slug: slug,
+              stage: stage,
+              event_type: :error,
+              agent: "daemon",
+              message: "auto_retry #{action}:#{rationale}"
+            )
+          rescue StandardError => e
+            @logger&.event(:auto_retry_audit_error, message: e.message)
+          end
+        end
+
+        def bound_details(payload)
+          # Drop bulky probe excerpts for the task event surface.
+          payload = payload.dup
+          if payload[:probes]
+            payload[:probes] = Array(payload[:probes]).map do |p|
+              probe = {}
+              %w[name ok timed_out duration_sec exit_status error stdout stderr detail completion_record].each do |key|
+                value = if p.is_a?(Hash) && p.key?(key)
+                  p[key]
+                elsif p.is_a?(Hash) && p.key?(key.to_sym)
+                  p[key.to_sym]
+                end
+                probe[key] = value unless value.nil?
+              end
+              probe
+            end
+          end
+          payload
+        end
+
+        def row_get(row, key)
+          if row.respond_to?(key)
+            row.public_send(key)
+          elsif row.is_a?(Hash)
+            row[key] || row[key.to_s]
+          end
+        end
+      end
+    end
+  end
+end
